function _ts_decorate(decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for(var i = decorators.length - 1; i >= 0; i--)if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
}
function _ts_metadata(k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
}
import { Check, Column, Entity, ManyToOne, PrimaryColumn } from "typeorm";
import { id } from "../id.js";
import { User } from "./user.js";
import { Note } from "./note.js";
export let Bite = class Bite {
    id;
    createdAt;
    uri;
    userId;
    user;
    userHost;
    targetUserId;
    targetUser;
    targetBiteId;
    targetBite;
    targetNoteId;
    targetNote;
    replied;
};
_ts_decorate([
    PrimaryColumn(id()),
    _ts_metadata("design:type", String)
], Bite.prototype, "id", void 0);
_ts_decorate([
    Column("timestamp with time zone"),
    _ts_metadata("design:type", typeof Date === "undefined" ? Object : Date)
], Bite.prototype, "createdAt", void 0);
_ts_decorate([
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "null if local"
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "uri", void 0);
_ts_decorate([
    Column(id()),
    _ts_metadata("design:type", String)
], Bite.prototype, "userId", void 0);
_ts_decorate([
    ManyToOne(()=>User, {
        onDelete: "CASCADE"
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "user", void 0);
_ts_decorate([
    Column("varchar", {
        length: 512,
        nullable: true,
        comment: "[Denormalized]"
    }),
    _ts_metadata("design:type", String)
], Bite.prototype, "userHost", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "targetUserId", void 0);
_ts_decorate([
    ManyToOne(()=>User, {
        onDelete: "CASCADE",
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "targetUser", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "targetBiteId", void 0);
_ts_decorate([
    ManyToOne(()=>Bite, {
        onDelete: "CASCADE",
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "targetBite", void 0);
_ts_decorate([
    Column({
        ...id(),
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "targetNoteId", void 0);
_ts_decorate([
    ManyToOne(()=>Note, {
        onDelete: "CASCADE",
        nullable: true
    }),
    _ts_metadata("design:type", Object)
], Bite.prototype, "targetNote", void 0);
_ts_decorate([
    Column("boolean", {
        default: true
    }),
    _ts_metadata("design:type", Boolean)
], Bite.prototype, "replied", void 0);
Bite = _ts_decorate([
    Entity(),
    Check(`"targetUserId" IS NOT NULL OR "targetBiteId" IS NOT NULL OR "targetNoteId" IS NOT NULL`)
], Bite);
